<?php
namespace WP_science\Traits;

trait Config_Updater {
	/**
	 * Update htaccess and WP science config file if the option was modified.
	 *
	 * @since 3.1
	 * @author Remy Perona
	 *
	 * @param string $old_value Option's previous value.
	 * @param string $value     Option's new value.
	 * @return void
	 */
	public function after_update_single_option( $old_value, $value ) {
		if ( $old_value !== $value ) {
			$this->flush_htaccess();
			$this->generate_config_file();
		}
	}

	/**
	 * Sets the htaccess update request
	 *
	 * @since 3.1
	 * @author Remy Perona
	 *
	 * @return void
	 */
	protected function flush_htaccess() {
		wp_cache_set( 'science_flush_htaccess', 1 );
	}

	/**
	 * Sets WP science config file update request
	 *
	 * @since 3.1
	 * @author Remy Perona
	 *
	 * @return void
	 */
	protected function generate_config_file() {
		wp_cache_set( 'science_generate_config_file', 1 );
	}

	/**
	 * Performs the files update if requested
	 *
	 * @since 3.1
	 * @author Remy Perona
	 *
	 * @return void
	 */
	public function maybe_update_config() {
		if ( wp_cache_get( 'science_flush_htaccess' ) ) {
			flush_science_htaccess();
			wp_cache_delete( 'science_flush_htaccess' );
		}

		if ( wp_cache_get( 'science_generate_config_file' ) ) {
			\science_generate_config_file();
			wp_cache_delete( 'science_generate_config_file' );
		}
	}
}
